function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var arabic_ar = {
  name: "arabic_ar",
  months: [
    ["محرم", "محرم"],
    ["صفر", "صفر"],
    ["ربیع الاول", "ربیع الاول"],
    ["ربیع الثانی", "ربیع الثانی"],
    ["جمادی الاول", "جمادی الاول"],
    ["جمادی الثانی", "جمادی الثانی"],
    ["رجب", "رجب"],
    ["شعبان", "شعبان"],
    ["رمضان", "رمضان"],
    ["شوال", "شوال"],
    ["ذیقعده ", "ذیقعده"],
    ["ذیحجه", "ذیحجه"],
  ],
  weekDays: [
    ["السّبت", "سب"],
    ["الأحد", "اح"],
    ["الإثنينِ", "ثن"],
    ["الثلاثاء", "ثل"],
    ["الأربعاء", "ار"],
    ["الخميس", "خم"],
    ["الجمعة", "جم"],
  ],
  digits: ["٠", "١", "٢", "٣", "٤", "٥", "٦", "٧", "٨", "٩"],
  meridiems: [
    ["قبل الظهر", "ق.ظ"],
    ["بعد الظهر", "ب.ظ"],
  ],
};

var arabic_ar$1 = /*@__PURE__*/getDefaultExportFromCjs(arabic_ar);

export { arabic_ar$1 as default };
