function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var gregorian_ar = {
  name: "gregorian_ar",
  months: [
    ["يناير", "ينا"],
    ["فبراير", "فبر"],
    ["مارس", "ما"],
    ["إبريل", "إبر"],
    ["مايو", "ما"],
    ["يونيو", "يو"],
    ["يوليو", "يوليو"],
    ["أغسطس", "أغس"],
    ["سبتمبر", "سب"],
    ["أكتوبر", "اک"],
    ["نوفمبر", "نو"],
    ["ديسمبر", "دس"],
  ],
  weekDays: [
    ["السّبت", "سب"],
    ["الأحد", "اح"],
    ["الإثنينِ", "ثن"],
    ["الثلاثاء", "ثل"],
    ["الأربعاء", "ار"],
    ["الخميس", "خم"],
    ["الجمعة", "جم"],
  ],
  digits: ["٠", "١", "٢", "٣", "٤", "٥", "٦", "٧", "٨", "٩"],
  meridiems: [
    ["قبل الظهر", "ق.ظ"],
    ["بعد الظهر", "ب.ظ"],
  ],
};

var gregorian_ar$1 = /*@__PURE__*/getDefaultExportFromCjs(gregorian_ar);

export { gregorian_ar$1 as default };
