function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var gregorian_fa = {
  name: "gregorian_fa",
  months: [
    ["ژانویه", "ژان"],
    ["فوریه", "فور"],
    ["مارس", "ما"],
    ["آوریل", "آور"],
    ["مه", "مه"],
    ["ژوئن", "ژو"],
    ["ژوئیه", "ژوئیه"],
    ["اوت", "اوت"],
    ["سپتامبر", "سپ"],
    ["اکتبر", "اک"],
    ["نوامبر", "نو"],
    ["دسامبر", "دس"],
  ],
  weekDays: [
    ["شنبه", "شن"],
    ["یکشنبه", "یک"],
    ["دوشنبه", "دو"],
    ["سه‌شنبه", "سه"],
    ["چهارشنبه", "چهار"],
    ["پنجشنبه", "پنج"],
    ["جمعه", "جم"],
  ],
  digits: ["۰", "۱", "۲", "۳", "۴", "۵", "۶", "۷", "۸", "۹"],
  meridiems: [
    ["قبل از ظهر", "ق.ظ"],
    ["بعد از ظهر", "ب.ظ"],
  ],
};

var gregorian_fa$1 = /*@__PURE__*/getDefaultExportFromCjs(gregorian_fa);

export { gregorian_fa$1 as default };
