function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var indian_ar = {
  name: "indian_ar",
  months: [
    ["شيترا", "شیت"],
    ["فيشاخ", "فیش"],
    ["جیشتا", "جیش"],
    ["أشاد", "أشا"],
    ["شرافان", "شرا"],
    ["بهادرابادا", "بها"],
    ["اشوين", "اشو"],
    ["كارتيك", "کار"],
    ["أجراهيان", "اجر"],
    ["بوش", "بوش"],
    ["ماک", "ماک"],
    ["فالغون", "فال"],
  ],
  weekDays: [
    ["السّبت", "سب"],
    ["الأحد", "اح"],
    ["الإثنينِ", "ثن"],
    ["الثلاثاء", "ثل"],
    ["الأربعاء", "ار"],
    ["الخميس", "خم"],
    ["الجمعة", "جم"],
  ],
  digits: ["٠", "١", "٢", "٣", "٤", "٥", "٦", "٧", "٨", "٩"],
  meridiems: [
    ["قبل الظهر", "ق.ظ"],
    ["بعد الظهر", "ب.ظ"],
  ],
};

var indian_ar$1 = /*@__PURE__*/getDefaultExportFromCjs(indian_ar);

export { indian_ar$1 as default };
