function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var persian_en = {
  name: "persian_en",
  months: [
    ["Farvardin", "Far"],
    ["Ordibehesht", "Ord"],
    ["Khordad", "Kho"],
    ["Tir", "Tir"],
    ["Mordad", "Mor"],
    ["Shahrivar", "Sha"],
    ["Mehr", "Meh"],
    ["Aban", "Aba"],
    ["Azar", "Aza"],
    ["Dey", "Dey"],
    ["Bahman", "Bah"],
    ["Esfand", "Esf"],
  ],
  weekDays: [
    ["Shanbeh", "Sha"],
    ["YekShanbeh", "Yek"],
    ["Doshanbeh", "Do"],
    ["Seshanbeh", "Se"],
    ["Chaharshanbeh", "Cha"],
    ["Panjshanbeh", "Pan"],
    ["Jom'eh", "Jom"],
  ],
  digits: ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"],
  meridiems: [
    ["AM", "am"],
    ["PM", "pm"],
  ],
};

var persian_en$1 = /*@__PURE__*/getDefaultExportFromCjs(persian_en);

export { persian_en$1 as default };
