(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
	typeof define === 'function' && define.amd ? define(factory) :
	(global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.gregorian_fa = factory());
})(this, (function () { 'use strict';

	function getDefaultExportFromCjs (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
	}

	var gregorian_fa = {
	  name: "gregorian_fa",
	  months: [
	    ["ژانویه", "ژان"],
	    ["فوریه", "فور"],
	    ["مارس", "ما"],
	    ["آوریل", "آور"],
	    ["مه", "مه"],
	    ["ژوئن", "ژو"],
	    ["ژوئیه", "ژوئیه"],
	    ["اوت", "اوت"],
	    ["سپتامبر", "سپ"],
	    ["اکتبر", "اک"],
	    ["نوامبر", "نو"],
	    ["دسامبر", "دس"],
	  ],
	  weekDays: [
	    ["شنبه", "شن"],
	    ["یکشنبه", "یک"],
	    ["دوشنبه", "دو"],
	    ["سه‌شنبه", "سه"],
	    ["چهارشنبه", "چهار"],
	    ["پنجشنبه", "پنج"],
	    ["جمعه", "جم"],
	  ],
	  digits: ["۰", "۱", "۲", "۳", "۴", "۵", "۶", "۷", "۸", "۹"],
	  meridiems: [
	    ["قبل از ظهر", "ق.ظ"],
	    ["بعد از ظهر", "ب.ظ"],
	  ],
	};

	var gregorian_fa$1 = /*@__PURE__*/getDefaultExportFromCjs(gregorian_fa);

	return gregorian_fa$1;

}));
