function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var gregorian_pt_br = {
  name: "gregorian_pt_br",
  months: [
    ["Janeiro", "Jan"],
    ["Fevereiro", "Fev"],
    ["Março", "Mar"],
    ["Abril", "Abr"],
    ["Maio", "Mai"],
    ["Junho", "Jun"],
    ["Julho", "Jul"],
    ["Agosto", "Ago"],
    ["Setembro", "Set"],
    ["Outubro", "Out"],
    ["Novembro", "Nov"],
    ["Dezembro", "Dez"],
  ],
  weekDays: [
    ["Sabádo", "Sab"],
    ["Domingo", "Dom"],
    ["Segunda-feira", "Seg"],
    ["Terça-feira", "Ter"],
    ["Quarta-feira", "Qua"],
    ["Quinta-feira", "Qui"],
    ["Sexta-feira", "Sex"],
  ],
  digits: ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"],
  meridiems: [
    ["AM", "am"],
    ["PM", "pm"],
  ],
};

var gregorian_pt_br$1 = /*@__PURE__*/getDefaultExportFromCjs(gregorian_pt_br);

export { gregorian_pt_br$1 as default };
